From b7e83d5ba2955f1bbf0dc8c46a8ba4825970981e Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Pavel=20B=C5=99ezina?= <pbrezina@redhat.com>
Date: Tue, 14 May 2013 15:00:05 +0200
Subject: [PATCH 4/4] providers: refresh expired netgroups

https://fedorahosted.org/sssd/ticket/1713
---
 Makefile.am                       |   1 +
 src/providers/ad/ad_init.c        |  10 +++
 src/providers/ipa/ipa_init.c      |  10 +++
 src/providers/ldap/ldap_common.h  |   8 ++
 src/providers/ldap/ldap_init.c    |  11 +++
 src/providers/ldap/sdap_refresh.c | 159 ++++++++++++++++++++++++++++++++++++++
 6 files changed, 199 insertions(+)
 create mode 100644 src/providers/ldap/sdap_refresh.c

diff --git a/Makefile.am b/Makefile.am
index 3f4f34a1bd4abbcf0a5a1f555307ee98a98a7923..0e9a9085965bd0cee52b88041b8e40f9b6b0ec9b 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -1459,6 +1459,7 @@ libsss_ldap_common_la_SOURCES = \
     src/providers/ldap/sdap_range.c \
     src/providers/ldap/sdap_reinit.c \
     src/providers/ldap/sdap_dyndns.c \
+    src/providers/ldap/sdap_refresh.c \
     src/providers/ldap/sdap.c
 libsss_ldap_common_la_LDFLAGS = \
     -avoid-version
diff --git a/src/providers/ad/ad_init.c b/src/providers/ad/ad_init.c
index d5488ad07d179f654a53e6d10824b8db7e842bef..7d4704044f4656aaf514a735cf88057ea93febed 100644
--- a/src/providers/ad/ad_init.c
+++ b/src/providers/ad/ad_init.c
@@ -212,6 +212,16 @@ sssm_ad_id_init(struct be_ctx *bectx,
         }
     }
 
+    /* setup periodical refresh of expired records */
+    ret = be_refresh_add_cb(bectx->refresh_ctx, BE_REFRESH_TYPE_NETGROUPS,
+                            sdap_refresh_netgroups_send,
+                            sdap_refresh_netgroups_recv,
+                            sdap_ctx);
+    if (ret != EOK && ret != EEXIST) {
+        DEBUG(SSSDBG_MINOR_FAILURE, ("Periodical refresh of netgroups "
+              "will not work [%d]: %s\n", ret, strerror(ret)));
+    }
+
     *ops = &ad_id_ops;
     *pvt_data = ad_ctx;
 
diff --git a/src/providers/ipa/ipa_init.c b/src/providers/ipa/ipa_init.c
index 9676b781d1880b0869792a04e97a244d85e6417a..81da9ae2d4a1ce88643cb90106cbb021b4f380c0 100644
--- a/src/providers/ipa/ipa_init.c
+++ b/src/providers/ipa/ipa_init.c
@@ -234,6 +234,16 @@ int sssm_ipa_id_init(struct be_ctx *bectx,
         }
     }
 
+    /* setup periodical refresh of expired records */
+    ret = be_refresh_add_cb(bectx->refresh_ctx, BE_REFRESH_TYPE_NETGROUPS,
+                            sdap_refresh_netgroups_send,
+                            sdap_refresh_netgroups_recv,
+                            sdap_ctx);
+    if (ret != EOK && ret != EEXIST) {
+        DEBUG(SSSDBG_MINOR_FAILURE, ("Periodical refresh of netgroups "
+              "will not work [%d]: %s\n", ret, strerror(ret)));
+    }
+
     *ops = &ipa_id_ops;
     *pvt_data = ipa_ctx;
     ret = EOK;
diff --git a/src/providers/ldap/ldap_common.h b/src/providers/ldap/ldap_common.h
index 2d17b755808e58831b458bcc86a50eb74b1f1057..8dd54902e35aa8c01c032734dce0573142b73163 100644
--- a/src/providers/ldap/ldap_common.h
+++ b/src/providers/ldap/ldap_common.h
@@ -235,4 +235,12 @@ sdap_set_sasl_options(struct sdap_options *id_opts,
                       char *default_realm,
                       const char *keytab_path);
 
+struct tevent_req *sdap_refresh_netgroups_send(TALLOC_CTX *mem_ctx,
+                                               struct tevent_context *ev,
+                                               struct be_ctx *be_ctx,
+                                               char **names,
+                                               void *pvt);
+
+errno_t sdap_refresh_netgroups_recv(struct tevent_req *req);
+
 #endif /* _LDAP_COMMON_H_ */
diff --git a/src/providers/ldap/ldap_init.c b/src/providers/ldap/ldap_init.c
index f70c8f1b0b03e4acf434c6559a11ad79f9139b42..8e88bc9e9de9503753b78c81ae7ea1ecf7f4e52e 100644
--- a/src/providers/ldap/ldap_init.c
+++ b/src/providers/ldap/ldap_init.c
@@ -30,6 +30,7 @@
 #include "providers/ldap/sdap_autofs.h"
 #include "providers/ldap/sdap_idmap.h"
 #include "providers/fail_over_srv.h"
+#include "providers/dp_refresh.h"
 
 static void sdap_shutdown(struct be_req *req);
 
@@ -179,6 +180,16 @@ int sssm_ldap_id_init(struct be_ctx *bectx,
         goto done;
     }
 
+    /* setup periodical refresh of expired records */
+    ret = be_refresh_add_cb(bectx->refresh_ctx, BE_REFRESH_TYPE_NETGROUPS,
+                            sdap_refresh_netgroups_send,
+                            sdap_refresh_netgroups_recv,
+                            ctx);
+    if (ret != EOK && ret != EEXIST) {
+        DEBUG(SSSDBG_MINOR_FAILURE, ("Periodical refresh of netgroups "
+              "will not work [%d]: %s\n", ret, strerror(ret)));
+    }
+
     *ops = &sdap_id_ops;
     *pvt_data = ctx;
     ret = EOK;
diff --git a/src/providers/ldap/sdap_refresh.c b/src/providers/ldap/sdap_refresh.c
new file mode 100644
index 0000000000000000000000000000000000000000..1cc4cef1506c46ebc9cf2f3430b6ab19bf1e3a8c
--- /dev/null
+++ b/src/providers/ldap/sdap_refresh.c
@@ -0,0 +1,159 @@
+/*
+    Authors:
+        Pavel Březina <pbrezina@redhat.com>
+
+    Copyright (C) 2013 Red Hat
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <talloc.h>
+#include <tevent.h>
+
+#include "providers/ldap/sdap.h"
+#include "providers/ldap/ldap_common.h"
+
+struct sdap_refresh_netgroups_state {
+    struct tevent_context *ev;
+    struct sdap_id_ctx *id_ctx;
+    char **names;
+    size_t index;
+};
+
+static errno_t sdap_refresh_netgroups_step(struct tevent_req *req);
+static void sdap_refresh_netgroups_done(struct tevent_req *subreq);
+
+struct tevent_req *sdap_refresh_netgroups_send(TALLOC_CTX *mem_ctx,
+                                               struct tevent_context *ev,
+                                               struct be_ctx *be_ctx,
+                                               char **names,
+                                               void *pvt)
+{
+    struct sdap_refresh_netgroups_state *state = NULL;
+    struct tevent_req *req = NULL;
+    errno_t ret;
+
+    req = tevent_req_create(mem_ctx, &state,
+                            struct sdap_refresh_netgroups_state);
+    if (req == NULL) {
+        DEBUG(SSSDBG_CRIT_FAILURE, ("tevent_req_create() failed\n"));
+        return NULL;
+    }
+
+    state->ev = ev;
+    state->id_ctx = talloc_get_type(pvt, struct sdap_id_ctx);
+    state->names = names;
+    state->index = 0;
+
+    if (names == NULL) {
+        ret = EOK;
+        goto immediately;
+    }
+
+    ret = sdap_refresh_netgroups_step(req);
+    if (ret == EOK) {
+        DEBUG(SSSDBG_TRACE_FUNC, ("Nothing to refresh\n"));
+        goto immediately;
+    } else if (ret != EAGAIN) {
+        DEBUG(SSSDBG_CRIT_FAILURE, ("sdap_refresh_netgroups_step() failed "
+                                    "[%d]: %s\n", ret, sss_strerror(ret)));
+        goto immediately;
+    }
+
+    return req;
+
+immediately:
+    if (ret == EOK) {
+        tevent_req_done(req);
+    } else {
+        tevent_req_error(req, ret);
+    }
+    tevent_req_post(req, ev);
+
+    return req;
+}
+
+static errno_t sdap_refresh_netgroups_step(struct tevent_req *req)
+{
+    struct sdap_refresh_netgroups_state *state = NULL;
+    struct tevent_req *subreq = NULL;
+    const char *name = NULL;
+    errno_t ret;
+
+    state = tevent_req_data(req, struct sdap_refresh_netgroups_state);
+
+    if (state->names == NULL) {
+        ret = EOK;
+        goto done;
+    }
+
+    name = state->names[state->index];
+    if (name == NULL) {
+        ret = EOK;
+        goto done;
+    }
+
+    DEBUG(SSSDBG_TRACE_FUNC, ("Issuing refresh of netgroup %s\n", name));
+
+    subreq = ldap_netgroup_get_send(state, state->ev, state->id_ctx, name);
+    if (subreq == NULL) {
+        ret = ENOMEM;
+        goto done;
+    }
+
+    tevent_req_set_callback(subreq, sdap_refresh_netgroups_done, req);
+
+    state->index++;
+    ret = EAGAIN;
+
+done:
+    return ret;
+}
+
+static void sdap_refresh_netgroups_done(struct tevent_req *subreq)
+{
+    struct tevent_req *req = NULL;
+    errno_t dp_error;
+    errno_t ret;
+
+    req = tevent_req_callback_data(subreq, struct tevent_req);
+
+    ret = ldap_netgroup_get_recv(subreq, &dp_error);
+    talloc_zfree(subreq);
+    if (ret != EOK) {
+        DEBUG(SSSDBG_CRIT_FAILURE, ("Unable to refresh netgroup [dp_error: %d, "
+              "errno: %d]: %s\n", dp_error, ret, sss_strerror(ret)));
+        goto done;
+    }
+
+    ret = sdap_refresh_netgroups_step(req);
+    if (ret == EAGAIN) {
+        return;
+    }
+
+done:
+    if (ret != EOK) {
+        tevent_req_error(req, ret);
+        return;
+    }
+
+    tevent_req_done(req);
+}
+
+errno_t sdap_refresh_netgroups_recv(struct tevent_req *req)
+{
+    TEVENT_REQ_RETURN_ON_ERROR(req);
+
+    return EOK;
+}
-- 
1.7.11.7